import _mapValues from 'lodash-es/mapValues';
import _partial from 'lodash-es/partial';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import { Component, PropTypes, createElement } from 'react';
import { connect } from 'react-redux';
import createFieldProps from './createFieldProps';

import plain from './structure/plain';

var createConnectedField = function createConnectedField(_ref, _ref2, name) {
  var asyncValidate = _ref.asyncValidate;
  var blur = _ref.blur;
  var change = _ref.change;
  var focus = _ref.focus;
  var getFormState = _ref.getFormState;
  var initialValues = _ref.initialValues;
  var deepEqual = _ref2.deepEqual;
  var getIn = _ref2.getIn;

  var ConnectedField = function (_Component) {
    _inherits(ConnectedField, _Component);

    function ConnectedField() {
      _classCallCheck(this, ConnectedField);

      return _possibleConstructorReturn(this, Object.getPrototypeOf(ConnectedField).apply(this, arguments));
    }

    _createClass(ConnectedField, [{
      key: 'shouldComponentUpdate',
      value: function shouldComponentUpdate(nextProps) {
        return !deepEqual(this.props, nextProps);
      }
    }, {
      key: 'getRenderedComponent',
      value: function getRenderedComponent() {
        return this.refs.renderedComponent;
      }
    }, {
      key: 'render',
      value: function render() {
        var _props = this.props;
        var component = _props.component;
        var defaultValue = _props.defaultValue;
        var withRef = _props.withRef;

        var rest = _objectWithoutProperties(_props, ['component', 'defaultValue', 'withRef']);

        var props = createFieldProps(getIn, name, rest, this.syncError, initialValues && getIn(initialValues, name), defaultValue, asyncValidate);
        if (withRef) {
          props.ref = 'renderedComponent';
        }
        return createElement(component, props);
      }
    }, {
      key: 'syncError',
      get: function get() {
        var getSyncErrors = this.context._reduxForm.getSyncErrors;

        var error = plain.getIn(getSyncErrors(), name);
        // Because the error for this field might not be at a level in the error structure where
        // it can be set directly, it might need to be unwrapped from the _error property
        return error && error._error ? error._error : error;
      }
    }, {
      key: 'valid',
      get: function get() {
        var _props2 = this.props;
        var asyncError = _props2.asyncError;
        var submitError = _props2.submitError;


        var error = this.syncError || asyncError || submitError;

        return !error;
      }
    }]);

    return ConnectedField;
  }(Component);

  ConnectedField.propTypes = {
    component: PropTypes.oneOfType([PropTypes.func, PropTypes.string]).isRequired,
    defaultValue: PropTypes.any
  };

  ConnectedField.contextTypes = {
    _reduxForm: PropTypes.object
  };

  var actions = _mapValues({ blur: blur, change: change, focus: focus }, function (actionCreator) {
    return _partial(actionCreator, name);
  });
  var connector = connect(function (state, ownProps) {
    return {
      initial: getIn(getFormState(state), 'initial.' + name),
      value: getIn(getFormState(state), 'values.' + name),
      state: getIn(getFormState(state), 'fields.' + name),
      asyncError: getIn(getFormState(state), 'asyncErrors.' + name),
      submitError: getIn(getFormState(state), 'submitErrors.' + name),
      asyncValidating: getIn(getFormState(state), 'asyncValidating') === name,
      _value: ownProps.value // save value passed in (for checkboxes)
    };
  }, actions, undefined, { withRef: true });
  return connector(ConnectedField);
};

export default createConnectedField;