import _noop from 'lodash-es/noop';
import _partial from 'lodash-es/partial';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import createOnBlur from './events/createOnBlur';
import createOnChange from './events/createOnChange';
import createOnDragStart from './events/createOnDragStart';
import createOnDrop from './events/createOnDrop';
import createOnFocus from './events/createOnFocus';


var processProps = function processProps(props, _value) {
  var type = props.type;
  var value = props.value;

  var rest = _objectWithoutProperties(props, ['type', 'value']);

  if (type === 'checkbox') {
    return _extends({}, rest, {
      checked: !!value,
      type: type
    });
  }
  if (type === 'radio') {
    return _extends({}, rest, {
      checked: value === _value,
      type: type,
      value: _value
    });
  }
  if (type === 'select-multiple') {
    return _extends({}, rest, {
      type: type,
      value: value || []
    });
  }
  return props;
};

var createFieldProps = function createFieldProps(getIn, name, _ref, syncError, initialPropValue) {
  var asyncError = _ref.asyncError;
  var blur = _ref.blur;
  var change = _ref.change;
  var focus = _ref.focus;
  var initial = _ref.initial;
  var state = _ref.state;
  var submitError = _ref.submitError;
  var value = _ref.value;
  var _value = _ref._value;

  var rest = _objectWithoutProperties(_ref, ['asyncError', 'blur', 'change', 'focus', 'initial', 'state', 'submitError', 'value', '_value']);

  var defaultValue = arguments.length <= 5 || arguments[5] === undefined ? '' : arguments[5];
  var asyncValidate = arguments.length <= 6 || arguments[6] === undefined ? _noop : arguments[6];

  var error = syncError || asyncError || submitError;
  var onChange = createOnChange(change);
  var initialValue = initial || initialPropValue;
  return processProps(_extends({
    active: state && !!getIn(state, 'active'),
    dirty: value !== initialValue,
    error: error,
    invalid: !!error,
    name: name,
    onBlur: createOnBlur(blur, _partial(asyncValidate, name)),
    onChange: onChange,
    onDragStart: createOnDragStart(name, value),
    onDrop: createOnDrop(name, change),
    onFocus: createOnFocus(name, focus),
    onUpdate: onChange,
    pristine: value === initialValue,
    touched: !!(state && getIn(state, 'touched')),
    valid: !error,
    value: value == null ? defaultValue : value,
    visited: state && !!getIn(state, 'visited')
  }, rest), _value);
};

export default createFieldProps;