import _noop from 'lodash-es/noop';
import expect, { createSpy } from 'expect';

import createOnBlur from '../createOnBlur';

describe('createOnBlur', function () {
  it('should return a function', function () {
    expect(createOnBlur()).toExist().toBeA('function');
  });

  it('should return a function that calls blur with name and value', function () {
    var blur = createSpy();
    createOnBlur(blur)('bar');
    expect(blur).toHaveBeenCalled().toHaveBeenCalledWith('bar');
  });

  it('should return a function that calls blur with name and value from event', function () {
    var blur = createSpy();
    createOnBlur(blur)({
      target: {
        value: 'bar'
      },
      preventDefault: _noop,
      stopPropagation: _noop
    });
    expect(blur).toHaveBeenCalled().toHaveBeenCalledWith('bar');
  });

  it('should return a function that calls blur and then afterBlur with name and value', function () {
    var blur = createSpy();
    var afterBlur = createSpy();
    createOnBlur(blur, afterBlur)('bar');
    expect(blur).toHaveBeenCalled();
    expect(afterBlur).toHaveBeenCalled().toHaveBeenCalledWith('bar');
  });
});