function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

import isPromise from 'is-promise';
import SubmissionError from './SubmissionError';

var handleSubmit = function handleSubmit(submit, props, valid, asyncValidate, fields) {
  var dispatch = props.dispatch;
  var startSubmit = props.startSubmit;
  var stopSubmit = props.stopSubmit;
  var setSubmitFailed = props.setSubmitFailed;
  var syncErrors = props.syncErrors;
  var returnRejectedSubmitPromise = props.returnRejectedSubmitPromise;
  var values = props.values;


  if (valid) {
    var doSubmit = function doSubmit() {
      var result = submit(values, dispatch);
      if (isPromise(result)) {
        startSubmit();
        return result.then(function (submitResult) {
          stopSubmit();
          return submitResult;
        }).catch(function (submitError) {
          stopSubmit(submitError instanceof SubmissionError ? submitError.errors : undefined);
          if (returnRejectedSubmitPromise) {
            return Promise.reject(submitError);
          }
        });
      }
      return result;
    };

    var asyncValidateResult = asyncValidate && asyncValidate();
    if (asyncValidateResult) {
      return asyncValidateResult.then(doSubmit, function (asyncErrors) {
        setSubmitFailed.apply(undefined, _toConsumableArray(fields));
        if (returnRejectedSubmitPromise) {
          return Promise.reject(asyncErrors);
        }
      });
    } else {
      return doSubmit();
    }
  } else {
    setSubmitFailed.apply(undefined, _toConsumableArray(fields));

    if (returnRejectedSubmitPromise) {
      return Promise.reject(syncErrors);
    }
  }
};

export default handleSubmit;